using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;

public class UICallbacks : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
{
    public UnityEvent MouseHover;
    public UnityEvent MouseHoverEnd;

    public void OnPointerEnter(PointerEventData eventData)
    {
        MouseHover.Invoke();
    }

    public void OnPointerExit(PointerEventData eventData)
    {
        MouseHoverEnd.Invoke();
    }

    public void SetTooltipText(string text)
    {
        ModelViewerInterface.GetInstance().Tooltip.SetAsLastSibling();
        ModelViewerInterface.GetInstance().TooltipText.text = text;
    }
}
